package pl.edu.mimuw.cloudatlas.service.interpreter.interpreter.query.Absyn; // Java Package generated by the BNF Converter.

public class BasicExprSubC extends BasicExpr {
    public final BasicExpr basicexpr_1, basicexpr_2;

    public BasicExprSubC(BasicExpr p1, BasicExpr p2) {

        basicexpr_1 = p1;
        basicexpr_2 = p2;
    }

    public <R, A> R accept(pl.edu.mimuw.cloudatlas.service.interpreter.interpreter.query.Absyn.BasicExpr.Visitor<R, A> v, A arg) {

        return v.visit(this, arg);
    }

    public int hashCode() {

        return 37 * (this.basicexpr_1.hashCode()) + this.basicexpr_2.hashCode();
    }

    public boolean equals(Object o) {

        if (this == o) return true;
        if (o instanceof pl.edu.mimuw.cloudatlas.service.interpreter.interpreter.query.Absyn.BasicExprSubC) {
            pl.edu.mimuw.cloudatlas.service.interpreter.interpreter.query.Absyn.BasicExprSubC x = (pl.edu.mimuw.cloudatlas.service.interpreter.interpreter.query.Absyn.BasicExprSubC) o;
            return this.basicexpr_1.equals(x.basicexpr_1) && this.basicexpr_2.equals(x.basicexpr_2);
        }
        return false;
    }


}
